﻿<#
Vor der Ausführung folgenden Befehl in den Befehlsbereich einfügen, um die PowerShell-Ausführungsrichtlinie zu senken:
 
    Set-ExecutionPolicy -ExecutionPolicy Bypass -Scope Process -Force -Confirm:$false
 
 FYI:
 Wegen eines "Bugs" öffnet sich der Ordner-Browser nur beim 1. Mal im Vordergrund.
 Bei jedem weiterem Ausführen dieses Scripts rutscht er immer hinter das PowerShell-Fenster!
 Also einfach PowerShell Fenster minimieren.
#> 

$Script = { # =Scriptblock; Dient dazu, das Script in einer eigenen Session zu starten, um die aktuelle Session sauber zu halten von z. B. Variablen            
	Add-Type -AssemblyName System.Windows.Forms 
	
	Try { $MePath = Split-Path $PSCommandPath -Parent } Catch { } 
	$browser = New-Object System.Windows.Forms.FolderBrowserDialog -Property @{ 
		SelectedPath = $MePath 
		ShowNewFolderButton = $false 
		Description = 'Wähle den Ordner mit den Textdateien aus' 
	} 

	If ($browser.ShowDialog() -ne [System.Windows.Forms.DialogResult]::OK) { Return } 
	$FolderPath = $browser.SelectedPath 
	
	$InputFiles = Get-ChildItem $FolderPath -Filter *.txt 
	
	$Encoding = [Microsoft.PowerShell.Commands.FileSystemCmdletProviderEncoding]::([Microsoft.PowerShell.Commands.FileSystemCmdletProviderEncoding]::GetNames([Microsoft.PowerShell.Commands.FileSystemCmdletProviderEncoding]) | Sort | ogv -Title 'Wähle die Codierung der Textdateien aus' -PassThru) 
	If ($Encoding -in $null , '') { Return } 
	
	$Content = @() 
	Foreach ($File In $InputFiles) 
	{ 
		$Content+= Get-Content $File.FullName -Encoding $Encoding | Select @{ n = 'Ort' ; e = { $_ } } , @{ n = 'Gemeinde' ; e = { $File.BaseName } } 
	} 
	
	$Content | Group-Object -Property 'Ort' | select @{ n = 'Ort' ; e = { $_.Name } } , @{ n = 'Anzahl' ; e = { $_.Count } } , @{ n = 'Gemeinden' ; e = { $_.Group.Gemeinde -join "`n" } } | ogv 
} 
& $Script  # Scriptblock in eigenes Session aufrufen
